ListMenu — Smart UI React API
On this page + Quick start
Quick start · React
Complete starter source per framework. Run the scaffold/install command first, then replace the listed files with the full code below.
// src/main.tsx
import React from 'react';
import ReactDOM from 'react-dom/client';
import App from './App';
ReactDOM.createRoot(document.getElementById('root')!).render(
<React.StrictMode>
<App />
</React.StrictMode>
);// src/App.tsx
import { useEffect, useRef } from 'react';
import 'smart-webcomponents/source/styles/smart.default.css';
import { ListMenu } from 'smart-webcomponents-react/listmenu';
export default function App() {
const ref = useRef<ListMenu | null>(null);
useEffect(() => {
const el = ref.current as any;
if (!el) return;
el.dataSource = [
{ label: 'Products', items: [{ label: 'Grid' }, { label: 'Scheduler' }] },
{ label: 'Support', items: [{ label: 'Documentation' }, { label: 'Forum' }] }
];
el.addEventListener('change', (event: any) => console.log('change:', event.detail ?? event));
}, []);
return <ListMenu ref={ref} id="demo-listmenu" />;
}
For AI tooling
Developer Quick Reference
Component: ListMenu Framework: React Selector: smart-list-menu
API counts: 34 properties, 9 methods, 6 events
Common properties: 0, 1, 2, 3, 4, 5
Common methods: addItem(), back(), changePage(), checkItem(), getItem(), maximize()
Common events: expand, itemCheckChange, itemClick, scrollBottomReached, swipeleft, swiperight
Module hint: smart-webcomponents-react/listmenu
ListMenu allows you to present users a listing of options and sub options.
Component
ListMenu
ListMenu allows you to present users a listing of options and sub options.
Selector
<ListMenu>
Quick picks
Properties
Events
Methods
Properties
animationSpecifies or retrieves the current animation mode. When set to 'none', all animations are completely disabled; otherwise, the selected animation mode is enabled. Use this property to control whether animations play or are suppressed within the component."none" | "simple" | "advanced"
Specifies or retrieves the current animation mode. When set to 'none', all animations are completely disabled; otherwise, the selected animation mode is enabled. Use this property to control whether animations play or are suppressed within the component.
Allowed Values
- "none" - animation is disabled
- "simple" - ripple animation is disabled
- "advanced" - all animations are enabled
Default value
"advanced"Examples
Markup and runtime examples for animation:
JSX:
<ListMenu animation="none" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.animation = "simple";
Read the current value:
const animation = listmenuRef.current!.animation;
autoFocusOnMouseenterControls whether the element automatically receives keyboard focus when a user hovers the mouse pointer over it. If enabled, the element will become the active focus target on hover, allowing for keyboard interactions without requiring a click. If disabled, hovering does not change the focus state.boolean
Controls whether the element automatically receives keyboard focus when a user hovers the mouse pointer over it. If enabled, the element will become the active focus target on hover, allowing for keyboard interactions without requiring a click. If disabled, hovering does not change the focus state.
Default value
falseExamples
Markup and runtime examples for autoFocusOnMouseenter:
JSX — boolean prop:
<ListMenu autoFocusOnMouseenter={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.autoFocusOnMouseenter = false;
Read the current value:
const autoFocusOnMouseenter = listmenuRef.current!.autoFocusOnMouseenter;
checkableEnables top-level items within the ListMenu to support checkable states, allowing users to select or deselect these menu items with a checkbox or similar indicator. This feature provides enhanced interactivity by letting users clearly mark individual ListMenu options as checked or unchecked.boolean
Enables top-level items within the ListMenu to support checkable states, allowing users to select or deselect these menu items with a checkbox or similar indicator. This feature provides enhanced interactivity by letting users clearly mark individual ListMenu options as checked or unchecked.
Default value
falseExamples
Markup and runtime examples for checkable:
JSX — boolean prop:
<ListMenu checkable={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.checkable = false;
Read the current value:
const checkable = listmenuRef.current!.checkable;
checkboxesControls whether checkboxes and radio buttons can appear in the top-level groups of the ListMenu. This property applies exclusively to the ListMenu component itself, and does not affect subitems within smart-menu-item or smart-menu-items-group elements. For related functionality, refer to the checkable property.boolean
Controls whether checkboxes and radio buttons can appear in the top-level groups of the ListMenu. This property applies exclusively to the ListMenu component itself, and does not affect subitems within smart-menu-item or smart-menu-items-group elements. For related functionality, refer to the checkable property.
Default value
falseExamples
Markup and runtime examples for checkboxes:
JSX — boolean prop:
<ListMenu checkboxes={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.checkboxes = false;
Read the current value:
const checkboxes = listmenuRef.current!.checkboxes;
checkModeConfigures the selection behavior (check mode) for top-level ListMenu items (groups). This determines whether menu items can be selected individually, allow multiple selections, or behave like radio buttons, affecting how users interact with the menu."checkbox" | "radioButton"
Configures the selection behavior (check mode) for top-level ListMenu items (groups). This determines whether menu items can be selected individually, allow multiple selections, or behave like radio buttons, affecting how users interact with the menu.
Allowed Values
- "checkbox" - A check box is shown inside a menu group that is selected.
- "radioButton" - A radio dot is shown inside a menu group that is selected.
Default value
"checkbox"Examples
Markup and runtime examples for checkMode:
JSX:
<ListMenu checkMode="radioButton" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.checkMode = "checkbox";
Read the current value:
const checkMode = listmenuRef.current!.checkMode;
dataSourceSpecifies the data source to be displayed in the ListMenu component. The data source must be an array of objects, where each object represents a menu item with the following properties: label: string – The text displayed for the menu item. value: any – The unique value or identifier associated with the menu item. shortcut: string (optional) – A keyboard shortcut or hint displayed alongside the menu item. items: array (optional) – An array of submenu item objects, each following the same structure, allowing for the creation of nested or hierarchical menus. This structure enables the ListMenu to render both simple and multi-level menus, providing flexibility in how menu options and their shortcuts are presented to users.{label: string, shortcut: string, value: any, items: []}[]
Specifies the data source to be displayed in the ListMenu component. The data source must be an array of objects, where each object represents a menu item with the following properties:
label: string – The text displayed for the menu item.
value: any – The unique value or identifier associated with the menu item.
shortcut: string (optional) – A keyboard shortcut or hint displayed alongside the menu item.
items: array (optional) – An array of submenu item objects, each following the same structure, allowing for the creation of nested or hierarchical menus.
This structure enables the ListMenu to render both simple and multi-level menus, providing flexibility in how menu options and their shortcuts are presented to users.
Examples
Markup and runtime examples for dataSource:
JSX:
<ListMenu dataSource="[{ label: "File" }, { label: "Help" }]" />Imperative (ref from createRef / useRef):
listmenuRef.current!.dataSource = [{ label: 'File', items: [{ label: 'New', shortcut: 'Ctrl+N' }] }];Read the current value:
const dataSource = listmenuRef.current!.dataSource;
disabledDetermines whether the element is interactive or not. When enabled, users can interact with the element. When disabled, the element becomes non-interactive and typically appears visually distinct (e.g., grayed out) to indicate its inactive state.boolean
Determines whether the element is interactive or not. When enabled, users can interact with the element. When disabled, the element becomes non-interactive and typically appears visually distinct (e.g., grayed out) to indicate its inactive state.
Default value
falseExamples
Markup and runtime examples for disabled:
JSX — boolean prop:
<ListMenu disabled={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.disabled = false;
Read the current value:
const disabled = listmenuRef.current!.disabled;
displayLoadingIndicatorControls the visibility of the loading indicator. By default, the loading indicator is hidden; setting this option to true will display the indicator, while setting it to false will hide it.boolean
Controls the visibility of the loading indicator. By default, the loading indicator is hidden; setting this option to true will display the indicator, while setting it to false will hide it.
Default value
falseExamples
Markup and runtime examples for displayLoadingIndicator:
JSX — boolean prop:
<ListMenu displayLoadingIndicator={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.displayLoadingIndicator = false;
Read the current value:
const displayLoadingIndicator = listmenuRef.current!.displayLoadingIndicator;
displayMemberSpecifies which field in the data source should be used as the label for each item. This determines the text that will be displayed to represent the item in the user interface.string
Specifies which field in the data source should be used as the label for each item. This determines the text that will be displayed to represent the item in the user interface.
Default value
"label"Examples
Markup and runtime examples for displayMember:
JSX:
<ListMenu displayMember="title" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.displayMember = "caption";
Read the current value:
const displayMember = listmenuRef.current!.displayMember;
dropDownAppendToSpecifies a custom outer container to which the minimized dropdown will be appended. By default, the dropdown is appended to the ListMenu container. You can set this property to either an HTML element or a string representing the ID of an HTML element.string | HTMLElement
Specifies a custom outer container to which the minimized dropdown will be appended. By default, the dropdown is appended to the ListMenu container. You can set this property to either an HTML element or a string representing the ID of an HTML element.
Examples
Markup and runtime examples for dropDownAppendTo:
JSX:
<ListMenu dropDownAppendTo="body" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.dropDownAppendTo = "'customContainer'";
Read the current value:
const dropDownAppendTo = listmenuRef.current!.dropDownAppendTo;
dropDownOverlayIf this property is enabled, opening the element's minimized dropdown will display a transparent overlay that covers the area between the dropdown and the rest of the page content. This overlay visually separates the dropdown from other elements on the page and can also intercept clicks to prevent interactions with content outside the dropdown until it is closed.boolean
If this property is enabled, opening the element's minimized dropdown will display a transparent overlay that covers the area between the dropdown and the rest of the page content. This overlay visually separates the dropdown from other elements on the page and can also intercept clicks to prevent interactions with content outside the dropdown until it is closed.
Default value
falseExamples
Markup and runtime examples for dropDownOverlay:
JSX — boolean prop:
<ListMenu dropDownOverlay={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.dropDownOverlay = false;
Read the current value:
const dropDownOverlay = listmenuRef.current!.dropDownOverlay;
dropDownPositionSpecifies or retrieves the direction in which the ListMenu's minimized dropdown expands when opened, such as upward or downward. This property determines the alignment and positioning of the dropdown relative to the ListMenu component."auto" | "top-left" | "top-right" | "bottom-left" | "bottom-right" | "overlay-left" | "overlay-right"
Specifies or retrieves the direction in which the ListMenu's minimized dropdown expands when opened, such as upward or downward. This property determines the alignment and positioning of the dropdown relative to the ListMenu component.
Allowed Values
- "auto" - The position is automatically determined by measuring the available distance around the element for the drop down to open freely without being clipped by the edges of the browser. By default the drop down will try to open below the element. If the available space is not enough for the popup to appear it will open in one of the following directions, if possible: top, over.
- "top-left" - The drop down opens above and to the left of the seleted Item Group.
- "top-right" - The drop down opens above and to the right of the seleted Item Group.
- "bottom-left" - The drop down opens below and to the left of the seleted Item Group.
- "bottom-right" - The drop down opens below and to the right of the seleted Item Group.
- "overlay-left" - The drop down opens over the seleted Item Group by aligning to the left.
- "overlay-right" - The drop down opens over and to the left of the seleted Item Group by aligning to the right.
Default value
"auto"Examples
Markup and runtime examples for dropDownPosition:
JSX:
<ListMenu dropDownPosition="top-left" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.dropDownPosition = "top-right";
Read the current value:
const dropDownPosition = listmenuRef.current!.dropDownPosition;
enableMouseWheelActionControls whether users can scroll through menu items that overflow the visible area by using the mouse wheel. When enabled, using the mouse wheel will navigate vertically through menu items not currently visible within the menu’s viewport. When disabled, mouse wheel scrolling will have no effect on overflowing menu content.boolean
Controls whether users can scroll through menu items that overflow the visible area by using the mouse wheel. When enabled, using the mouse wheel will navigate vertically through menu items not currently visible within the menu’s viewport. When disabled, mouse wheel scrolling will have no effect on overflowing menu content.
Default value
falseExamples
Markup and runtime examples for enableMouseWheelAction:
JSX — boolean prop:
<ListMenu enableMouseWheelAction={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.enableMouseWheelAction = true;
Read the current value:
const enableMouseWheelAction = listmenuRef.current!.enableMouseWheelAction;
filterableControls the activation of menu item filtering functionality. When enabled, a filter input field appears at the top of the menu component, allowing users to search and display only the menu items that match the entered query. Note that filtering is limited to items currently rendered or visible in the menu's current view; items not present in the view will not be affected by the filter.boolean
Controls the activation of menu item filtering functionality. When enabled, a filter input field appears at the top of the menu component, allowing users to search and display only the menu items that match the entered query. Note that filtering is limited to items currently rendered or visible in the menu's current view; items not present in the view will not be affected by the filter.
Default value
falseExamples
Markup and runtime examples for filterable:
JSX — boolean prop:
<ListMenu filterable={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.filterable = false;
Read the current value:
const filterable = listmenuRef.current!.filterable;
filterInputPlaceholderSpecifies the placeholder text displayed inside the filter input field, guiding users on the expected input or action.string
Specifies the placeholder text displayed inside the filter input field, guiding users on the expected input or action.
Default value
""Examples
Markup and runtime examples for filterInputPlaceholder:
JSX:
<ListMenu filterInputPlaceholder="Enter a value:" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.filterInputPlaceholder = "Awaiting entry:";
Read the current value:
const filterInputPlaceholder = listmenuRef.current!.filterInputPlaceholder;
filterMemberSpecifies which property of the MenuItem will be used as the filtering criterion. By default, the filtering is performed using the label property of each MenuItem. You can change this setting to use other properties instead, such as value if you want to filter based on the MenuItem's value property, or textContent if you prefer to filter using the text content within the MenuItem. Additionally, you may specify any other property name to customize the filtering behavior according to your application's requirements.string
Specifies which property of the MenuItem will be used as the filtering criterion. By default, the filtering is performed using the label property of each MenuItem. You can change this setting to use other properties instead, such as value if you want to filter based on the MenuItem's value property, or textContent if you prefer to filter using the text content within the MenuItem. Additionally, you may specify any other property name to customize the filtering behavior according to your application's requirements.
Default value
"label"Examples
Markup and runtime examples for filterMember:
JSX:
<ListMenu filterMember="value" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.filterMember = "textContent";
Read the current value:
const filterMember = listmenuRef.current!.filterMember;
filterModeSpecifies the method used to filter or process data, such as selecting items based on certain criteria, applying search terms, or excluding specific values. This setting controls how data is displayed or retrieved according to the selected filtering mode."contains" | "containsIgnoreCase" | "doesNotContain" | "doesNotContainIgnoreCase" | "equals" | "equalsIgnoreCase" | "startsWith" | "startsWithIgnoreCase" | "endsWith" | "endsWithIgnoreCase"
Specifies the method used to filter or process data, such as selecting items based on certain criteria, applying search terms, or excluding specific values. This setting controls how data is displayed or retrieved according to the selected filtering mode.
Allowed Values
- "contains" - displays only items with labels that contain the filter string (case sensitive)
- "containsIgnoreCase" - displays only items with labels that contain the filter string (case insensitive)
- "doesNotContain" - displays only items with labels that do not contain the filter string (case sensitive)
- "doesNotContainIgnoreCase" - displays only items with labels that do not contain the filter string (case insensitive)
- "equals" - displays only items with labels that equal the filter string (case sensitive)
- "equalsIgnoreCase" - displays only items with labels that equal the filter string (case insensitive)
- "startsWith" - displays only items with labels that start with the filter string (case sensitive)
- "startsWithIgnoreCase" - displays only items with labels that start with the filter string (case insensitive)
- "endsWith" - displays only items with labels that end with the filter string (case sensitive)
- "endsWithIgnoreCase" - displays only items with labels that end with the filter string (case insensitive)
Default value
"containsIgnoreCase"Examples
Markup and runtime examples for filterMode:
JSX:
<ListMenu filterMode="contains" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.filterMode = "equals";
Read the current value:
const filterMode = listmenuRef.current!.filterMode;
groupedIf enabled, the items will be organized into groups based on the first letter of each item's name. Within each group, the items will be sorted alphabetically.boolean
If enabled, the items will be organized into groups based on the first letter of each item's name. Within each group, the items will be sorted alphabetically.
Default value
falseExamples
Markup and runtime examples for grouped:
JSX — boolean prop:
<ListMenu grouped={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.grouped = false;
Read the current value:
const grouped = listmenuRef.current!.grouped;
itemsMemberSpecifies the name of the field within the data source that contains the collection of subitems associated with each item group. This field is used to retrieve and bind the subitems for display or processing within the application.string
Specifies the name of the field within the data source that contains the collection of subitems associated with each item group. This field is used to retrieve and bind the subitems for display or processing within the application.
Default value
"items"Examples
Markup and runtime examples for itemsMember:
JSX:
<ListMenu itemsMember="children" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.itemsMember = "subitems";
Read the current value:
const itemsMember = listmenuRef.current!.itemsMember;
loadingIndicatorPlaceholderSpecifies the text to display alongside the loading indicator when the loader is visible and positioned at the top or bottom of the container. This text provides context or feedback to users during loading operations.string
Specifies the text to display alongside the loading indicator when the loader is visible and positioned at the top or bottom of the container. This text provides context or feedback to users during loading operations.
Default value
"Loading..."Examples
Markup and runtime examples for loadingIndicatorPlaceholder:
JSX:
<ListMenu loadingIndicatorPlaceholder="Incoming data" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.loadingIndicatorPlaceholder = "LOADING...";
Read the current value:
const loadingIndicatorPlaceholder = listmenuRef.current!.loadingIndicatorPlaceholder;
loadingIndicatorPositionSpecifies the exact location where the loading indicator will appear within the parent element. This controls whether the loading indicator is displayed at the top, center, bottom, or another defined position inside the element’s boundaries."bottom" | "center" | "top"
Specifies the exact location where the loading indicator will appear within the parent element. This controls whether the loading indicator is displayed at the top, center, bottom, or another defined position inside the element’s boundaries.
Allowed Values
- "bottom" - Positions the loading indicator at the bottom of the list menu.
- "center" - Positions the loading indicator at the center of the list menu.
- "top" - Positions the loading indicator at the bottom of the list menu.
Default value
"center"Examples
Markup and runtime examples for loadingIndicatorPosition:
JSX:
<ListMenu loadingIndicatorPosition="bottom" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.loadingIndicatorPosition = "top";
Read the current value:
const loadingIndicatorPosition = listmenuRef.current!.loadingIndicatorPosition;
localeSpecifies or retrieves the current language code (such as "en", "fr", or "es"), which determines the set of localized messages to use from the messages property. This property ensures that the appropriate language-specific messages are displayed to users based on their language selection or system settings.string
Specifies or retrieves the current language code (such as "en", "fr", or "es"), which determines the set of localized messages to use from the messages property. This property ensures that the appropriate language-specific messages are displayed to users based on their language selection or system settings.
Default value
"en"Examples
Markup and runtime examples for locale:
JSX:
<ListMenu locale="de" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.locale = "fr";
Read the current value:
const locale = listmenuRef.current!.locale;
localizeFormatFunctionA callback function that allows you to define custom formatting for messages returned by the Localization Module. Use this to modify how localized strings are generated and displayed, such as altering text templates, injecting dynamic values, or adjusting message structure before they are delivered to your application.function | null
A callback function that allows you to define custom formatting for messages returned by the Localization Module. Use this to modify how localized strings are generated and displayed, such as altering text templates, injecting dynamic values, or adjusting message structure before they are delivered to your application.
Examples
Markup and runtime examples for localizeFormatFunction:
JSX:
<ListMenu localizeFormatFunction="function(defaultMessage, message, messageArguments){return '...'}" />Imperative (ref from createRef / useRef):
listmenuRef.current!.localizeFormatFunction = "function(defaultMessage, message, messageArguments){return '...'}";Read the current value:
const localizeFormatFunction = listmenuRef.current!.localizeFormatFunction;
messagesDefines or retrieves an object containing localized strings used throughout the widget’s interface. This property is intended to facilitate internationalization by allowing you to provide translations for various UI text elements. It is typically used in combination with the locale property, which determines the currently active language or regional format.object
Defines or retrieves an object containing localized strings used throughout the widget’s interface. This property is intended to facilitate internationalization by allowing you to provide translations for various UI text elements. It is typically used in combination with the locale property, which determines the currently active language or regional format.
Default value
"en": {
"propertyUnknownType": "'{{name}}' property is with undefined 'type' member!",
"propertyInvalidValue": "Invalid '{{name}}' property value! Actual value: {{actualValue}}, Expected value: {{value}}!",
"propertyInvalidValueType": "Invalid '{{name}}' property value type! Actual type: {{actualType}}, Expected type: {{type}}!",
"elementNotInDOM": "Element does not exist in DOM! Please, add the element to the DOM, before invoking a method.",
"moduleUndefined": "Module is undefined.",
"missingReference": "{{elementType}}: Missing reference to {{files}}.",
"htmlTemplateNotSuported": "{{elementType}}: Browser doesn't support HTMLTemplate elements.",
"invalidTemplate": "{{elementType}}: '{{property}}' property accepts a string that must match the id of an HTMLTemplate element from the DOM."
}
Examples
Markup and runtime examples for messages:
JSX:
<ListMenu messages="{"de":{"propertyUnknownType":"Die Eigenschaft '{{name}}' hat ein nicht definiertes 'type'-Member!","propertyInvalidValue":"Ungultiger Eigenschaftswert '{{name}}'! Aktueller Wert: {{actualValue}}, Erwarteter Wert: {{value}}!","propertyInvalidValueType":"Ungultiger Eigenschaftswert '{{name}}'! Aktueller Wert: {{actualType}}, Erwarteter Wert: {{type}}!","elementNotInDOM":"Element existiert nicht in DOM! Bitte fugen Sie das Element zum DOM hinzu, bevor Sie eine Methode aufrufen.","moduleUndefined":"Modul ist nicht definiert.","missingReference":"{{elementType}}: Fehlender Verweis auf {{files}}.","htmlTemplateNotSuported":"{{elementType}}: Browser unterstutzt keine HTMLTemplate-Elemente.","invalidTemplate":"{{elementType}}: '{{property}}' Die Eigenschaft akzeptiert eine Zeichenfolge, die mit der ID eines HTMLTemplate-Elements aus dem DOM ubereinstimmen muss."}}" />Imperative (ref from createRef / useRef):
listmenuRef.current!.messages = {"en":{"propertyUnknownType":"'{{name}}' property is with undefined 'type' member!","propertyInvalidValue":"Invalid '{{name}}' property value! Actual value: {{actualValue}}, Expected value: {{value}}!","propertyInvalidValueType":"Invalid '{{name}}' property value type! Actual type: {{actualType}}, Expected type: {{type}}!","elementNotInDOM":"Element does not exist in DOM! Please, add the element to the DOM, before invoking a method.","moduleUndefined":"Module is undefined.","missingReference":"{{elementType}}: Missing reference to {{files}}.","htmlTemplateNotSuported":"{{elementType}}: Browser doesn't support HTMLTemplate elements.","invalidTemplate":"{{elementType}}: '{{property}}' property accepts a string that must match the id of an HTMLTemplate element from the DOM."}};Read the current value:
const messages = listmenuRef.current!.messages;
minimizeIconTemplateEnables the use of a custom minimize icon by specifying an HTMLTemplateElement. This property accepts either the ID of an HTMLTemplateElement (as a string) or a direct reference to the HTMLTemplateElement instance. The content of the provided template will be rendered in place of the default minimize icon.string
Enables the use of a custom minimize icon by specifying an HTMLTemplateElement. This property accepts either the ID of an HTMLTemplateElement (as a string) or a direct reference to the HTMLTemplateElement instance. The content of the provided template will be rendered in place of the default minimize icon.
Default value
"null"Examples
Markup and runtime examples for minimizeIconTemplate:
JSX:
<ListMenu minimizeIconTemplate="template1" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.minimizeIconTemplate = "template2";
Read the current value:
const minimizeIconTemplate = listmenuRef.current!.minimizeIconTemplate;
minimizeWidthSpecifies the minimum width, in pixels, that the ListMenu must reach before automatically switching from its normal (expanded) mode to minimized mode. If this value is set to null, the ListMenu will remain in its normal mode regardless of its width and will not minimize automatically.number | null
Specifies the minimum width, in pixels, that the ListMenu must reach before automatically switching from its normal (expanded) mode to minimized mode. If this value is set to null, the ListMenu will remain in its normal mode regardless of its width and will not minimize automatically.
Examples
Markup and runtime examples for minimizeWidth:
JSX:
<ListMenu minimizeWidth="100" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.minimizeWidth = 200;
Read the current value:
const minimizeWidth = listmenuRef.current!.minimizeWidth;
overflowDefines or retrieves the behavior of the ListMenu's scroll buttons, specifying how they appear and function when the menu content exceeds the visible area. This property controls whether scroll buttons are shown, when they become visible, and how users can interact with them to navigate through the list."auto" | "hidden" | "scroll"
Defines or retrieves the behavior of the ListMenu's scroll buttons, specifying how they appear and function when the menu content exceeds the visible area. This property controls whether scroll buttons are shown, when they become visible, and how users can interact with them to navigate through the list.
Allowed Values
- "auto" - The scroll buttons are automatically shown/hidden depending on the visibility of the items. If there's an item that is not visible the appropriate scroll button will appear in order to fully scroll to it.
- "hidden" - The scroll buttons are hidden.
- "scroll" - The scroll buttons are always visible.
Default value
"auto"Examples
Markup and runtime examples for overflow:
JSX:
<ListMenu overflow="hidden" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.overflow = "scroll";
Read the current value:
const overflow = listmenuRef.current!.overflow;
readonlyIf the element has the "readonly" attribute, users can view its content but cannot modify or edit it. While the element remains focusable and its text can be selected or copied, any user attempts to change its value will be blocked, ensuring the data remains unchanged.boolean
If the element has the "readonly" attribute, users can view its content but cannot modify or edit it. While the element remains focusable and its text can be selected or copied, any user attempts to change its value will be blocked, ensuring the data remains unchanged.
Default value
falseExamples
Markup and runtime examples for readonly:
JSX — boolean prop:
<ListMenu readonly={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.readonly = true;
Read the current value:
const readonly = listmenuRef.current!.readonly;
rightToLeftSpecifies or retrieves a value that determines whether the element's text and layout direction are set to support right-to-left (RTL) languages, such as Arabic or Hebrew. When enabled, the element and its contents will display text and align elements according to RTL conventions.boolean
Specifies or retrieves a value that determines whether the element's text and layout direction are set to support right-to-left (RTL) languages, such as Arabic or Hebrew. When enabled, the element and its contents will display text and align elements according to RTL conventions.
Default value
falseExamples
Markup and runtime examples for rightToLeft:
JSX — boolean prop:
<ListMenu rightToLeft={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.rightToLeft = false;
Read the current value:
const rightToLeft = listmenuRef.current!.rightToLeft;
scrollModeSpecifies whether to display a traditional scrollbar or custom scroll buttons when the content exceeds the boundaries of an element’s container. This setting controls the method users can use to navigate overflow content within the element."scrollbar" | "scrollButtons"
Specifies whether to display a traditional scrollbar or custom scroll buttons when the content exceeds the boundaries of an element’s container. This setting controls the method users can use to navigate overflow content within the element.
Allowed Values
- "scrollbar" - displays scrollbar
- "scrollButtons" - displays scroll buttons
Default value
"scrollbar"Examples
Markup and runtime examples for scrollMode:
JSX:
<ListMenu scrollMode="scrollButtons" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.scrollMode = "scrollbar";
Read the current value:
const scrollMode = listmenuRef.current!.scrollMode;
themeSpecifies the visual theme to apply to the element. The selected theme controls the element’s overall appearance, including colors, fonts, and styling, ensuring a consistent look and feel throughout the user interface.string
Specifies the visual theme to apply to the element. The selected theme controls the element’s overall appearance, including colors, fonts, and styling, ensuring a consistent look and feel throughout the user interface.
Default value
""Examples
Markup and runtime examples for theme:
JSX:
<ListMenu theme="blue" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.theme = "red";
Read the current value:
const theme = listmenuRef.current!.theme;
unfocusableWhen set to true, the element becomes unfocusable, meaning it cannot receive input focus via keyboard navigation (such as the Tab key), mouse clicks, or scripting methods.boolean
When set to true, the element becomes unfocusable, meaning it cannot receive input focus via keyboard navigation (such as the Tab key), mouse clicks, or scripting methods.
Default value
falseExamples
Markup and runtime examples for unfocusable:
JSX — boolean prop:
<ListMenu unfocusable={true} />Imperative (ref from createRef / useRef):
listmenuRef.current!.unfocusable = false;
Read the current value:
const unfocusable = listmenuRef.current!.unfocusable;
unlockKeyDefines or retrieves the unlockKey property, a unique identifier or code required to unlock and grant access to the product’s features or content.string
Defines or retrieves the unlockKey property, a unique identifier or code required to unlock and grant access to the product’s features or content.
Default value
""Examples
Markup and runtime examples for unlockKey:
JSX:
<ListMenu unlockKey="" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.unlockKey = "1111-2222-3333-4444-5555";
Read the current value:
const unlockKey = listmenuRef.current!.unlockKey;
valueMemberSpecifies the name of the field in the data source whose value will be assigned as the item's value property. This field is used to uniquely identify each item within the data collection.string
Specifies the name of the field in the data source whose value will be assigned as the item's value property. This field is used to uniquely identify each item within the data collection.
Default value
"value"Examples
Markup and runtime examples for valueMember:
JSX:
<ListMenu valueMember="info" />
Imperative (ref from createRef / useRef):
listmenuRef.current!.valueMember = "details";
Read the current value:
const valueMember = listmenuRef.current!.valueMember;
Events
onExpandThis event is triggered whenever a smart-menu-items-group component is expanded by the user, indicating that the associated menu group has been opened to reveal its child menu items. Developers can use this event to perform actions such as loading dynamic content, updating UI states, or triggering additional functionality when a menu group becomes visible.CustomEvent
This event is triggered whenever a smart-menu-items-group component is expanded by the user, indicating that the associated menu group has been opened to reveal its child menu items. Developers can use this event to perform actions such as loading dynamic content, updating UI states, or triggering additional functionality when a menu group becomes visible.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onExpand
Arguments
evCustomEvent
ev.detailObject
ev.detail.item - The menu item that was expanded.
ev.detail.label - The label of the item that was expanded.
ev.detail.value - The value of the item that was expanded.
ev.detail.path - The path of the item that was expanded, e.g. '0.1', '1.1.2'.
ev.detail.children - The children of the item that was expanded.
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for expand using the pattern that matches your stack.
JSX
<ListMenu onExpand={handleExpand} />Handler
function handleExpand(event: CustomEvent) {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value,
path = detail.path,
children = detail.children;
// handle event …
}
onItemCheckChangeThis event is triggered whenever the checked or unchecked state of a menu item is modified—such as when a user selects or deselects a checkbox or toggle option within a menu. It allows you to respond to changes in the check state of menu items, enabling dynamic UI updates or additional actions based on the user's selection.CustomEvent
This event is triggered whenever the checked or unchecked state of a menu item is modified—such as when a user selects or deselects a checkbox or toggle option within a menu. It allows you to respond to changes in the check state of menu items, enabling dynamic UI updates or additional actions based on the user's selection.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onItemCheckChange
Arguments
evCustomEvent
ev.detailObject
ev.detail.item - The menu item which state was changed.
ev.detail.label - The label of the item which state was changed.
ev.detail.value - The value of the item which state was changed.
ev.detail.checked - The checked state of the toggled item. If false the item is not toggled.
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for itemCheckChange using the pattern that matches your stack.
JSX
<ListMenu onItemCheckChange={handleItemCheckChange} />Handler
function handleItemCheckChange(event: CustomEvent) {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value,
checked = detail.checked;
// handle event …
}
onItemClickThis event is triggered whenever a user interacts with the menu by clicking on one of its list items. The event provides details about the specific item selected, allowing you to execute custom logic in response to the user's selection.CustomEvent
This event is triggered whenever a user interacts with the menu by clicking on one of its list items. The event provides details about the specific item selected, allowing you to execute custom logic in response to the user's selection.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onItemClick
Arguments
evCustomEvent
ev.detailObject
ev.detail.item - The menu item that was clicked.
ev.detail.label - The label of the clicked item.
ev.detail.value - The value of the clicked item.
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for itemClick using the pattern that matches your stack.
JSX
<ListMenu onItemClick={handleItemClick} />Handler
function handleItemClick(event: CustomEvent) {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value;
// handle event …
}
onScrollBottomReachedThis event is triggered when the user reaches the bottom of the ListMenu by scrolling. It can be used to detect when additional actions are needed, such as loading more items or displaying a message, once the user has viewed all currently visible content in the ListMenu.CustomEvent
This event is triggered when the user reaches the bottom of the ListMenu by scrolling. It can be used to detect when additional actions are needed, such as loading more items or displaying a message, once the user has viewed all currently visible content in the ListMenu.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onScrollBottomReached
Arguments
evCustomEvent
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for scrollBottomReached using the pattern that matches your stack.
JSX
<ListMenu onScrollBottomReached={handleScrollBottomReached} />Handler
function handleScrollBottomReached(event: CustomEvent) {
// handle event …
}
onSwipeleftThis event is triggered when the user performs a leftward swipe gesture within the ListMenu component, typically indicating an intent to reveal additional options, delete an item, or navigate to a different view. It is designed to respond exclusively to horizontal swipes that start inside the ListMenu area.CustomEvent
This event is triggered when the user performs a leftward swipe gesture within the ListMenu component, typically indicating an intent to reveal additional options, delete an item, or navigate to a different view. It is designed to respond exclusively to horizontal swipes that start inside the ListMenu area.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onSwipeleft
Arguments
evCustomEvent
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for swipeleft using the pattern that matches your stack.
JSX
<ListMenu onSwipeleft={handleSwipeleft} />Handler
function handleSwipeleft(event: CustomEvent) {
// handle event …
}
onSwiperightThis event is triggered when the user performs a rightward swipe gesture within the ListMenu component. It can be used to detect and handle user interactions such as revealing additional options, navigating to a new view, or initiating specific actions in response to the right swipe inside the ListMenu area.CustomEvent
This event is triggered when the user performs a rightward swipe gesture within the ListMenu component. It can be used to detect and handle user interactions such as revealing additional options, navigating to a new view, or initiating specific actions in response to the right swipe inside the ListMenu area.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onSwiperight
Arguments
evCustomEvent
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for swiperight using the pattern that matches your stack.
JSX
<ListMenu onSwiperight={handleSwiperight} />Handler
function handleSwiperight(event: CustomEvent) {
// handle event …
}
Methods
addItem( Item: HTMLElement, Parent?: HTMLElement | string): voidAppends a new item to the end of the existing list, expanding the list by one element.
Appends a new item to the end of the existing list, expanding the list by one element.
Arguments
ItemHTMLElement
A smart-menu-item to add to the List Menu.
Parent?HTMLElement | string
The smart-menu-items-group (or its id or numeric path) to add the item to.
Through a React ref to the wrapper component:
listmenuRef.current?.addItem("document.createElement('smart-menu-item')","0");
Try a demo showcasing the addItem method.
back( animation?: boolean): voidNavigates to the previous page within the group of menu items (`smart-menu-items-group`). This function moves the user’s focus or view to the preceding set of menu options, enabling seamless backward navigation in multi-page or scrollable menu interfaces.
Navigates to the previous page within the group of menu items (`smart-menu-items-group`). This function moves the user’s focus or view to the preceding set of menu options, enabling seamless backward navigation in multi-page or scrollable menu interfaces.
Arguments
animation?boolean
If set to false, disables collapse animation even if animation is enabled for the element
Through a React ref to the wrapper component:
listmenuRef.current?.back();
Try a demo showcasing the back method.
changePage( id: string): voidNavigates the user to a specific page or section within the application identified as "smart-menu-items-group." This action typically triggers a transition or redirect, bringing the "smart-menu-items-group" content into view for the user. Suitable for menu navigation or directing users to targeted groups within a menu structure.
Navigates the user to a specific page or section within the application identified as "smart-menu-items-group." This action typically triggers a transition or redirect, bringing the "smart-menu-items-group" content into view for the user. Suitable for menu navigation or directing users to targeted groups within a menu structure.
Arguments
idstring
The id or numeric path of a page (smart-menu-items-group).
Through a React ref to the wrapper component:
listmenuRef.current?.changePage("0.0");
Try a demo showcasing the changePage method.
checkItem( item: HTMLElement | string): voidMarks an item as checked, indicating that it has been selected or completed. This action typically updates the item's status property (e.g., `checked: true`) within the JSON data.
Marks an item as checked, indicating that it has been selected or completed. This action typically updates the item's status property (e.g., `checked: true`) within the JSON data.
Arguments
itemHTMLElement | string
smart-menu-item/smart-menu-items-group (or its id or numeric path).
Through a React ref to the wrapper component:
listmenuRef.current?.checkItem("0.0");
getItem( id: string): HTMLElementRetrieves a specific item using either its unique identifier (ID) or a numeric path that locates the item within a hierarchical structure.
Retrieves a specific item using either its unique identifier (ID) or a numeric path that locates the item within a hierarchical structure.
Arguments
idstring
The id or numeric path of an item
ReturnsHTMLElement
Through a React ref to the wrapper component:
const result = listmenuRef.current?.getItem("0.0");
maximize(): voidExpands the List Menu to its maximum available size, displaying all menu items for full visibility and easier selection.
Expands the List Menu to its maximum available size, displaying all menu items for full visibility and easier selection.
Through a React ref to the wrapper component:
listmenuRef.current?.maximize();
minimize(): voidCollapses the List Menu to save screen space. When minimized, the full menu is hidden and replaced with a single icon, allowing users to expand the menu again if needed. This improves the user interface by providing a cleaner, less cluttered appearance while maintaining quick access to menu options.
Collapses the List Menu to save screen space. When minimized, the full menu is hidden and replaced with a single icon, allowing users to expand the menu again if needed. This improves the user interface by providing a cleaner, less cluttered appearance while maintaining quick access to menu options.
Through a React ref to the wrapper component:
listmenuRef.current?.minimize();
removeItem( item: HTMLElement | string): voidRemoves a specified item from the collection or list. If the item exists, it is deleted; otherwise, no changes are made. This operation typically identifies the item by its unique key, index, or value.
Removes a specified item from the collection or list. If the item exists, it is deleted; otherwise, no changes are made. This operation typically identifies the item by its unique key, index, or value.
Arguments
itemHTMLElement | string
The smart-menu-item/smart-menu-items-group (or its id or numeric path) to remove.
Through a React ref to the wrapper component:
listmenuRef.current?.removeItem("0.0");
uncheckItem( item: HTMLElement | string): voidRemoves the checkmark from a selected item, resetting its state to unchecked or unselected. This action is typically used to indicate that the item is not active, chosen, or included in a selection.
Removes the checkmark from a selected item, resetting its state to unchecked or unselected. This action is typically used to indicate that the item is not active, chosen, or included in a selection.
Arguments
itemHTMLElement | string
smart-menu-item/smart-menu-items-group (or its id or numeric path).
Through a React ref to the wrapper component:
listmenuRef.current?.uncheckItem("0.0");
CSS Variables
--smart-list-menu-default-widthvar()
Default value
"var(--smart-box-width)"smartListMenu default width
--smart-list-menu-default-heightvar()
Default value
"var(--smart-box-height)"smartListMenu default height
--smart-list-menu-filter-input-vertical-offsetvar()
Default value
"5px"Defines vertical offset of the ListMenu's filter input.
--smart-list-menu-filter-input-horizontal-offsetvar()
Default value
"5px"Defines horizontal offset of the ListMenu's filter input.

ListMenu — Smart UI Vue API
On this page + Quick start
Quick start · Vue
Complete starter source per framework. Run the scaffold/install command first, then replace the listed files with the full code below.
// src/main.ts
import { createApp } from 'vue'
import App from './App.vue'
const app = createApp(App)
app.config.isCustomElement = tag => tag.startsWith('smart-');
app.mount('#app')// src/App.vue
<script setup lang="ts">
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.listmenu.js';
const widgetRef = ref<ListMenu | null>(null);
onMounted(() => {
const el = widgetRef.value as any;
if (!el) return;
el.dataSource = [
{ label: 'Products', items: [{ label: 'Grid' }, { label: 'Scheduler' }] },
{ label: 'Support', items: [{ label: 'Documentation' }, { label: 'Forum' }] }
];
el.addEventListener('change', (event: any) => console.log('change:', event.detail ?? event));
});
</script>
<template>
<smart-list-menu ref="widgetRef" id="demo-listmenu" />
</template>
For AI tooling
Developer Quick Reference
Component: ListMenu Framework: Vue Selector: smart-list-menu
API counts: 34 properties, 9 methods, 6 events
Common properties: 0, 1, 2, 3, 4, 5
Common methods: addItem(), back(), changePage(), checkItem(), getItem(), maximize()
Common events: expand, itemCheckChange, itemClick, scrollBottomReached, swipeleft, swiperight
Module hint: smart-webcomponents/source/modules/smart.listmenu.js
ListMenu allows you to present users a listing of options and sub options.
Class
ListMenu
ListMenu allows you to present users a listing of options and sub options.
Selector
smart-list-menu
Quick picks
Properties
Events
Methods
Properties
animationSpecifies or retrieves the current animation mode. When set to 'none', all animations are completely disabled; otherwise, the selected animation mode is enabled. Use this property to control whether animations play or are suppressed within the component."none" | "simple" | "advanced"
Specifies or retrieves the current animation mode. When set to 'none', all animations are completely disabled; otherwise, the selected animation mode is enabled. Use this property to control whether animations play or are suppressed within the component.
Allowed Values
- "none" - animation is disabled
- "simple" - ripple animation is disabled
- "advanced" - all animations are enabled
Default value
"advanced"Examples
Markup and runtime examples for animation:
Template:
<template> <smart-list-menu ref="listmenu" animation="none" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.animation = "simple";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const animation = w.animation;
}
autoFocusOnMouseenterControls whether the element automatically receives keyboard focus when a user hovers the mouse pointer over it. If enabled, the element will become the active focus target on hover, allowing for keyboard interactions without requiring a click. If disabled, hovering does not change the focus state.boolean
Controls whether the element automatically receives keyboard focus when a user hovers the mouse pointer over it. If enabled, the element will become the active focus target on hover, allowing for keyboard interactions without requiring a click. If disabled, hovering does not change the focus state.
Default value
falseExamples
Markup and runtime examples for autoFocusOnMouseenter:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" auto-focus-on-mouseenter /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.autoFocusOnMouseenter = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const autoFocusOnMouseenter = w.autoFocusOnMouseenter;
}
checkableEnables top-level items within the ListMenu to support checkable states, allowing users to select or deselect these menu items with a checkbox or similar indicator. This feature provides enhanced interactivity by letting users clearly mark individual ListMenu options as checked or unchecked.boolean
Enables top-level items within the ListMenu to support checkable states, allowing users to select or deselect these menu items with a checkbox or similar indicator. This feature provides enhanced interactivity by letting users clearly mark individual ListMenu options as checked or unchecked.
Default value
falseExamples
Markup and runtime examples for checkable:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" checkable /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.checkable = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const checkable = w.checkable;
}
checkboxesControls whether checkboxes and radio buttons can appear in the top-level groups of the ListMenu. This property applies exclusively to the ListMenu component itself, and does not affect subitems within smart-menu-item or smart-menu-items-group elements. For related functionality, refer to the checkable property.boolean
Controls whether checkboxes and radio buttons can appear in the top-level groups of the ListMenu. This property applies exclusively to the ListMenu component itself, and does not affect subitems within smart-menu-item or smart-menu-items-group elements. For related functionality, refer to the checkable property.
Default value
falseExamples
Markup and runtime examples for checkboxes:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" checkboxes /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.checkboxes = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const checkboxes = w.checkboxes;
}
checkModeConfigures the selection behavior (check mode) for top-level ListMenu items (groups). This determines whether menu items can be selected individually, allow multiple selections, or behave like radio buttons, affecting how users interact with the menu."checkbox" | "radioButton"
Configures the selection behavior (check mode) for top-level ListMenu items (groups). This determines whether menu items can be selected individually, allow multiple selections, or behave like radio buttons, affecting how users interact with the menu.
Allowed Values
- "checkbox" - A check box is shown inside a menu group that is selected.
- "radioButton" - A radio dot is shown inside a menu group that is selected.
Default value
"checkbox"Examples
Markup and runtime examples for checkMode:
Template:
<template> <smart-list-menu ref="listmenu" check-mode="radioButton" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.checkMode = "checkbox";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const checkMode = w.checkMode;
}
dataSourceSpecifies the data source to be displayed in the ListMenu component. The data source must be an array of objects, where each object represents a menu item with the following properties: label: string – The text displayed for the menu item. value: any – The unique value or identifier associated with the menu item. shortcut: string (optional) – A keyboard shortcut or hint displayed alongside the menu item. items: array (optional) – An array of submenu item objects, each following the same structure, allowing for the creation of nested or hierarchical menus. This structure enables the ListMenu to render both simple and multi-level menus, providing flexibility in how menu options and their shortcuts are presented to users.{label: string, shortcut: string, value: any, items: []}[]
Specifies the data source to be displayed in the ListMenu component. The data source must be an array of objects, where each object represents a menu item with the following properties:
label: string – The text displayed for the menu item.
value: any – The unique value or identifier associated with the menu item.
shortcut: string (optional) – A keyboard shortcut or hint displayed alongside the menu item.
items: array (optional) – An array of submenu item objects, each following the same structure, allowing for the creation of nested or hierarchical menus.
This structure enables the ListMenu to render both simple and multi-level menus, providing flexibility in how menu options and their shortcuts are presented to users.
Examples
Markup and runtime examples for dataSource:
Template:
<template>
<smart-list-menu ref="listmenu" data-source="[{ label: "File" }, { label: "Help" }]" />
</template>Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.dataSource = [{ label: 'File', items: [{ label: 'New', shortcut: 'Ctrl+N' }] }];
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const dataSource = w.dataSource;
}
disabledDetermines whether the element is interactive or not. When enabled, users can interact with the element. When disabled, the element becomes non-interactive and typically appears visually distinct (e.g., grayed out) to indicate its inactive state.boolean
Determines whether the element is interactive or not. When enabled, users can interact with the element. When disabled, the element becomes non-interactive and typically appears visually distinct (e.g., grayed out) to indicate its inactive state.
Default value
falseExamples
Markup and runtime examples for disabled:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" disabled /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.disabled = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const disabled = w.disabled;
}
displayLoadingIndicatorControls the visibility of the loading indicator. By default, the loading indicator is hidden; setting this option to true will display the indicator, while setting it to false will hide it.boolean
Controls the visibility of the loading indicator. By default, the loading indicator is hidden; setting this option to true will display the indicator, while setting it to false will hide it.
Default value
falseExamples
Markup and runtime examples for displayLoadingIndicator:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" display-loading-indicator /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.displayLoadingIndicator = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const displayLoadingIndicator = w.displayLoadingIndicator;
}
displayMemberSpecifies which field in the data source should be used as the label for each item. This determines the text that will be displayed to represent the item in the user interface.string
Specifies which field in the data source should be used as the label for each item. This determines the text that will be displayed to represent the item in the user interface.
Default value
"label"Examples
Markup and runtime examples for displayMember:
Template:
<template> <smart-list-menu ref="listmenu" display-member="title" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.displayMember = "caption";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const displayMember = w.displayMember;
}
dropDownAppendToSpecifies a custom outer container to which the minimized dropdown will be appended. By default, the dropdown is appended to the ListMenu container. You can set this property to either an HTML element or a string representing the ID of an HTML element.string | HTMLElement
Specifies a custom outer container to which the minimized dropdown will be appended. By default, the dropdown is appended to the ListMenu container. You can set this property to either an HTML element or a string representing the ID of an HTML element.
Examples
Markup and runtime examples for dropDownAppendTo:
Template:
<template> <smart-list-menu ref="listmenu" drop-down-append-to="body" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.dropDownAppendTo = "'customContainer'";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const dropDownAppendTo = w.dropDownAppendTo;
}
dropDownOverlayIf this property is enabled, opening the element's minimized dropdown will display a transparent overlay that covers the area between the dropdown and the rest of the page content. This overlay visually separates the dropdown from other elements on the page and can also intercept clicks to prevent interactions with content outside the dropdown until it is closed.boolean
If this property is enabled, opening the element's minimized dropdown will display a transparent overlay that covers the area between the dropdown and the rest of the page content. This overlay visually separates the dropdown from other elements on the page and can also intercept clicks to prevent interactions with content outside the dropdown until it is closed.
Default value
falseExamples
Markup and runtime examples for dropDownOverlay:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" drop-down-overlay /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.dropDownOverlay = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const dropDownOverlay = w.dropDownOverlay;
}
dropDownPositionSpecifies or retrieves the direction in which the ListMenu's minimized dropdown expands when opened, such as upward or downward. This property determines the alignment and positioning of the dropdown relative to the ListMenu component."auto" | "top-left" | "top-right" | "bottom-left" | "bottom-right" | "overlay-left" | "overlay-right"
Specifies or retrieves the direction in which the ListMenu's minimized dropdown expands when opened, such as upward or downward. This property determines the alignment and positioning of the dropdown relative to the ListMenu component.
Allowed Values
- "auto" - The position is automatically determined by measuring the available distance around the element for the drop down to open freely without being clipped by the edges of the browser. By default the drop down will try to open below the element. If the available space is not enough for the popup to appear it will open in one of the following directions, if possible: top, over.
- "top-left" - The drop down opens above and to the left of the seleted Item Group.
- "top-right" - The drop down opens above and to the right of the seleted Item Group.
- "bottom-left" - The drop down opens below and to the left of the seleted Item Group.
- "bottom-right" - The drop down opens below and to the right of the seleted Item Group.
- "overlay-left" - The drop down opens over the seleted Item Group by aligning to the left.
- "overlay-right" - The drop down opens over and to the left of the seleted Item Group by aligning to the right.
Default value
"auto"Examples
Markup and runtime examples for dropDownPosition:
Template:
<template> <smart-list-menu ref="listmenu" drop-down-position="top-left" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.dropDownPosition = "top-right";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const dropDownPosition = w.dropDownPosition;
}
enableMouseWheelActionControls whether users can scroll through menu items that overflow the visible area by using the mouse wheel. When enabled, using the mouse wheel will navigate vertically through menu items not currently visible within the menu’s viewport. When disabled, mouse wheel scrolling will have no effect on overflowing menu content.boolean
Controls whether users can scroll through menu items that overflow the visible area by using the mouse wheel. When enabled, using the mouse wheel will navigate vertically through menu items not currently visible within the menu’s viewport. When disabled, mouse wheel scrolling will have no effect on overflowing menu content.
Default value
falseExamples
Markup and runtime examples for enableMouseWheelAction:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" enable-mouse-wheel-action /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.enableMouseWheelAction = true;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const enableMouseWheelAction = w.enableMouseWheelAction;
}
filterableControls the activation of menu item filtering functionality. When enabled, a filter input field appears at the top of the menu component, allowing users to search and display only the menu items that match the entered query. Note that filtering is limited to items currently rendered or visible in the menu's current view; items not present in the view will not be affected by the filter.boolean
Controls the activation of menu item filtering functionality. When enabled, a filter input field appears at the top of the menu component, allowing users to search and display only the menu items that match the entered query. Note that filtering is limited to items currently rendered or visible in the menu's current view; items not present in the view will not be affected by the filter.
Default value
falseExamples
Markup and runtime examples for filterable:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" filterable /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.filterable = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const filterable = w.filterable;
}
filterInputPlaceholderSpecifies the placeholder text displayed inside the filter input field, guiding users on the expected input or action.string
Specifies the placeholder text displayed inside the filter input field, guiding users on the expected input or action.
Default value
""Examples
Markup and runtime examples for filterInputPlaceholder:
Template:
<template> <smart-list-menu ref="listmenu" filter-input-placeholder="Enter a value:" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.filterInputPlaceholder = "Awaiting entry:";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const filterInputPlaceholder = w.filterInputPlaceholder;
}
filterMemberSpecifies which property of the MenuItem will be used as the filtering criterion. By default, the filtering is performed using the label property of each MenuItem. You can change this setting to use other properties instead, such as value if you want to filter based on the MenuItem's value property, or textContent if you prefer to filter using the text content within the MenuItem. Additionally, you may specify any other property name to customize the filtering behavior according to your application's requirements.string
Specifies which property of the MenuItem will be used as the filtering criterion. By default, the filtering is performed using the label property of each MenuItem. You can change this setting to use other properties instead, such as value if you want to filter based on the MenuItem's value property, or textContent if you prefer to filter using the text content within the MenuItem. Additionally, you may specify any other property name to customize the filtering behavior according to your application's requirements.
Default value
"label"Examples
Markup and runtime examples for filterMember:
Template:
<template> <smart-list-menu ref="listmenu" filter-member="value" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.filterMember = "textContent";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const filterMember = w.filterMember;
}
filterModeSpecifies the method used to filter or process data, such as selecting items based on certain criteria, applying search terms, or excluding specific values. This setting controls how data is displayed or retrieved according to the selected filtering mode."contains" | "containsIgnoreCase" | "doesNotContain" | "doesNotContainIgnoreCase" | "equals" | "equalsIgnoreCase" | "startsWith" | "startsWithIgnoreCase" | "endsWith" | "endsWithIgnoreCase"
Specifies the method used to filter or process data, such as selecting items based on certain criteria, applying search terms, or excluding specific values. This setting controls how data is displayed or retrieved according to the selected filtering mode.
Allowed Values
- "contains" - displays only items with labels that contain the filter string (case sensitive)
- "containsIgnoreCase" - displays only items with labels that contain the filter string (case insensitive)
- "doesNotContain" - displays only items with labels that do not contain the filter string (case sensitive)
- "doesNotContainIgnoreCase" - displays only items with labels that do not contain the filter string (case insensitive)
- "equals" - displays only items with labels that equal the filter string (case sensitive)
- "equalsIgnoreCase" - displays only items with labels that equal the filter string (case insensitive)
- "startsWith" - displays only items with labels that start with the filter string (case sensitive)
- "startsWithIgnoreCase" - displays only items with labels that start with the filter string (case insensitive)
- "endsWith" - displays only items with labels that end with the filter string (case sensitive)
- "endsWithIgnoreCase" - displays only items with labels that end with the filter string (case insensitive)
Default value
"containsIgnoreCase"Examples
Markup and runtime examples for filterMode:
Template:
<template> <smart-list-menu ref="listmenu" filter-mode="contains" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.filterMode = "equals";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const filterMode = w.filterMode;
}
groupedIf enabled, the items will be organized into groups based on the first letter of each item's name. Within each group, the items will be sorted alphabetically.boolean
If enabled, the items will be organized into groups based on the first letter of each item's name. Within each group, the items will be sorted alphabetically.
Default value
falseExamples
Markup and runtime examples for grouped:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" grouped /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.grouped = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const grouped = w.grouped;
}
itemsMemberSpecifies the name of the field within the data source that contains the collection of subitems associated with each item group. This field is used to retrieve and bind the subitems for display or processing within the application.string
Specifies the name of the field within the data source that contains the collection of subitems associated with each item group. This field is used to retrieve and bind the subitems for display or processing within the application.
Default value
"items"Examples
Markup and runtime examples for itemsMember:
Template:
<template> <smart-list-menu ref="listmenu" items-member="children" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.itemsMember = "subitems";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const itemsMember = w.itemsMember;
}
loadingIndicatorPlaceholderSpecifies the text to display alongside the loading indicator when the loader is visible and positioned at the top or bottom of the container. This text provides context or feedback to users during loading operations.string
Specifies the text to display alongside the loading indicator when the loader is visible and positioned at the top or bottom of the container. This text provides context or feedback to users during loading operations.
Default value
"Loading..."Examples
Markup and runtime examples for loadingIndicatorPlaceholder:
Template:
<template> <smart-list-menu ref="listmenu" loading-indicator-placeholder="Incoming data" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.loadingIndicatorPlaceholder = "LOADING...";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const loadingIndicatorPlaceholder = w.loadingIndicatorPlaceholder;
}
loadingIndicatorPositionSpecifies the exact location where the loading indicator will appear within the parent element. This controls whether the loading indicator is displayed at the top, center, bottom, or another defined position inside the element’s boundaries."bottom" | "center" | "top"
Specifies the exact location where the loading indicator will appear within the parent element. This controls whether the loading indicator is displayed at the top, center, bottom, or another defined position inside the element’s boundaries.
Allowed Values
- "bottom" - Positions the loading indicator at the bottom of the list menu.
- "center" - Positions the loading indicator at the center of the list menu.
- "top" - Positions the loading indicator at the bottom of the list menu.
Default value
"center"Examples
Markup and runtime examples for loadingIndicatorPosition:
Template:
<template> <smart-list-menu ref="listmenu" loading-indicator-position="bottom" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.loadingIndicatorPosition = "top";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const loadingIndicatorPosition = w.loadingIndicatorPosition;
}
localeSpecifies or retrieves the current language code (such as "en", "fr", or "es"), which determines the set of localized messages to use from the messages property. This property ensures that the appropriate language-specific messages are displayed to users based on their language selection or system settings.string
Specifies or retrieves the current language code (such as "en", "fr", or "es"), which determines the set of localized messages to use from the messages property. This property ensures that the appropriate language-specific messages are displayed to users based on their language selection or system settings.
Default value
"en"Examples
Markup and runtime examples for locale:
Template:
<template> <smart-list-menu ref="listmenu" locale="de" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.locale = "fr";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const locale = w.locale;
}
localizeFormatFunctionA callback function that allows you to define custom formatting for messages returned by the Localization Module. Use this to modify how localized strings are generated and displayed, such as altering text templates, injecting dynamic values, or adjusting message structure before they are delivered to your application.function | null
A callback function that allows you to define custom formatting for messages returned by the Localization Module. Use this to modify how localized strings are generated and displayed, such as altering text templates, injecting dynamic values, or adjusting message structure before they are delivered to your application.
Examples
Markup and runtime examples for localizeFormatFunction:
Template:
<template>
<smart-list-menu ref="listmenu" localize-format-function="function(defaultMessage, message, messageArguments){return '...'}" />
</template>Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.localizeFormatFunction = "function(defaultMessage, message, messageArguments){return '...'}";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const localizeFormatFunction = w.localizeFormatFunction;
}
messagesDefines or retrieves an object containing localized strings used throughout the widget’s interface. This property is intended to facilitate internationalization by allowing you to provide translations for various UI text elements. It is typically used in combination with the locale property, which determines the currently active language or regional format.object
Defines or retrieves an object containing localized strings used throughout the widget’s interface. This property is intended to facilitate internationalization by allowing you to provide translations for various UI text elements. It is typically used in combination with the locale property, which determines the currently active language or regional format.
Default value
"en": {
"propertyUnknownType": "'{{name}}' property is with undefined 'type' member!",
"propertyInvalidValue": "Invalid '{{name}}' property value! Actual value: {{actualValue}}, Expected value: {{value}}!",
"propertyInvalidValueType": "Invalid '{{name}}' property value type! Actual type: {{actualType}}, Expected type: {{type}}!",
"elementNotInDOM": "Element does not exist in DOM! Please, add the element to the DOM, before invoking a method.",
"moduleUndefined": "Module is undefined.",
"missingReference": "{{elementType}}: Missing reference to {{files}}.",
"htmlTemplateNotSuported": "{{elementType}}: Browser doesn't support HTMLTemplate elements.",
"invalidTemplate": "{{elementType}}: '{{property}}' property accepts a string that must match the id of an HTMLTemplate element from the DOM."
}
Examples
Markup and runtime examples for messages:
Template:
<template>
<smart-list-menu ref="listmenu" messages="{"de":{"propertyUnknownType":"Die Eigenschaft '{{name}}' hat ein nicht definiertes 'type'-Member!","propertyInvalidValue":"Ungultiger Eigenschaftswert '{{name}}'! Aktueller Wert: {{actualValue}}, Erwarteter Wert: {{value}}!","propertyInvalidValueType":"Ungultiger Eigenschaftswert '{{name}}'! Aktueller Wert: {{actualType}}, Erwarteter Wert: {{type}}!","elementNotInDOM":"Element existiert nicht in DOM! Bitte fugen Sie das Element zum DOM hinzu, bevor Sie eine Methode aufrufen.","moduleUndefined":"Modul ist nicht definiert.","missingReference":"{{elementType}}: Fehlender Verweis auf {{files}}.","htmlTemplateNotSuported":"{{elementType}}: Browser unterstutzt keine HTMLTemplate-Elemente.","invalidTemplate":"{{elementType}}: '{{property}}' Die Eigenschaft akzeptiert eine Zeichenfolge, die mit der ID eines HTMLTemplate-Elements aus dem DOM ubereinstimmen muss."}}" />
</template>Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.messages = {"en":{"propertyUnknownType":"'{{name}}' property is with undefined 'type' member!","propertyInvalidValue":"Invalid '{{name}}' property value! Actual value: {{actualValue}}, Expected value: {{value}}!","propertyInvalidValueType":"Invalid '{{name}}' property value type! Actual type: {{actualType}}, Expected type: {{type}}!","elementNotInDOM":"Element does not exist in DOM! Please, add the element to the DOM, before invoking a method.","moduleUndefined":"Module is undefined.","missingReference":"{{elementType}}: Missing reference to {{files}}.","htmlTemplateNotSuported":"{{elementType}}: Browser doesn't support HTMLTemplate elements.","invalidTemplate":"{{elementType}}: '{{property}}' property accepts a string that must match the id of an HTMLTemplate element from the DOM."}};
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const messages = w.messages;
}
minimizeIconTemplateEnables the use of a custom minimize icon by specifying an HTMLTemplateElement. This property accepts either the ID of an HTMLTemplateElement (as a string) or a direct reference to the HTMLTemplateElement instance. The content of the provided template will be rendered in place of the default minimize icon.string
Enables the use of a custom minimize icon by specifying an HTMLTemplateElement. This property accepts either the ID of an HTMLTemplateElement (as a string) or a direct reference to the HTMLTemplateElement instance. The content of the provided template will be rendered in place of the default minimize icon.
Default value
"null"Examples
Markup and runtime examples for minimizeIconTemplate:
Template:
<template> <smart-list-menu ref="listmenu" minimize-icon-template="template1" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.minimizeIconTemplate = "template2";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const minimizeIconTemplate = w.minimizeIconTemplate;
}
minimizeWidthSpecifies the minimum width, in pixels, that the ListMenu must reach before automatically switching from its normal (expanded) mode to minimized mode. If this value is set to null, the ListMenu will remain in its normal mode regardless of its width and will not minimize automatically.number | null
Specifies the minimum width, in pixels, that the ListMenu must reach before automatically switching from its normal (expanded) mode to minimized mode. If this value is set to null, the ListMenu will remain in its normal mode regardless of its width and will not minimize automatically.
Examples
Markup and runtime examples for minimizeWidth:
Template:
<template> <smart-list-menu ref="listmenu" minimize-width="100" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.minimizeWidth = 200;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const minimizeWidth = w.minimizeWidth;
}
overflowDefines or retrieves the behavior of the ListMenu's scroll buttons, specifying how they appear and function when the menu content exceeds the visible area. This property controls whether scroll buttons are shown, when they become visible, and how users can interact with them to navigate through the list."auto" | "hidden" | "scroll"
Defines or retrieves the behavior of the ListMenu's scroll buttons, specifying how they appear and function when the menu content exceeds the visible area. This property controls whether scroll buttons are shown, when they become visible, and how users can interact with them to navigate through the list.
Allowed Values
- "auto" - The scroll buttons are automatically shown/hidden depending on the visibility of the items. If there's an item that is not visible the appropriate scroll button will appear in order to fully scroll to it.
- "hidden" - The scroll buttons are hidden.
- "scroll" - The scroll buttons are always visible.
Default value
"auto"Examples
Markup and runtime examples for overflow:
Template:
<template> <smart-list-menu ref="listmenu" overflow="hidden" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.overflow = "scroll";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const overflow = w.overflow;
}
readonlyIf the element has the "readonly" attribute, users can view its content but cannot modify or edit it. While the element remains focusable and its text can be selected or copied, any user attempts to change its value will be blocked, ensuring the data remains unchanged.boolean
If the element has the "readonly" attribute, users can view its content but cannot modify or edit it. While the element remains focusable and its text can be selected or copied, any user attempts to change its value will be blocked, ensuring the data remains unchanged.
Default value
falseExamples
Markup and runtime examples for readonly:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" readonly /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.readonly = true;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const readonly = w.readonly;
}
rightToLeftSpecifies or retrieves a value that determines whether the element's text and layout direction are set to support right-to-left (RTL) languages, such as Arabic or Hebrew. When enabled, the element and its contents will display text and align elements according to RTL conventions.boolean
Specifies or retrieves a value that determines whether the element's text and layout direction are set to support right-to-left (RTL) languages, such as Arabic or Hebrew. When enabled, the element and its contents will display text and align elements according to RTL conventions.
Default value
falseExamples
Markup and runtime examples for rightToLeft:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" right-to-left /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.rightToLeft = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const rightToLeft = w.rightToLeft;
}
scrollModeSpecifies whether to display a traditional scrollbar or custom scroll buttons when the content exceeds the boundaries of an element’s container. This setting controls the method users can use to navigate overflow content within the element."scrollbar" | "scrollButtons"
Specifies whether to display a traditional scrollbar or custom scroll buttons when the content exceeds the boundaries of an element’s container. This setting controls the method users can use to navigate overflow content within the element.
Allowed Values
- "scrollbar" - displays scrollbar
- "scrollButtons" - displays scroll buttons
Default value
"scrollbar"Examples
Markup and runtime examples for scrollMode:
Template:
<template> <smart-list-menu ref="listmenu" scroll-mode="scrollButtons" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.scrollMode = "scrollbar";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const scrollMode = w.scrollMode;
}
themeSpecifies the visual theme to apply to the element. The selected theme controls the element’s overall appearance, including colors, fonts, and styling, ensuring a consistent look and feel throughout the user interface.string
Specifies the visual theme to apply to the element. The selected theme controls the element’s overall appearance, including colors, fonts, and styling, ensuring a consistent look and feel throughout the user interface.
Default value
""Examples
Markup and runtime examples for theme:
Template:
<template> <smart-list-menu ref="listmenu" theme="blue" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.theme = "red";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const theme = w.theme;
}
unfocusableWhen set to true, the element becomes unfocusable, meaning it cannot receive input focus via keyboard navigation (such as the Tab key), mouse clicks, or scripting methods.boolean
When set to true, the element becomes unfocusable, meaning it cannot receive input focus via keyboard navigation (such as the Tab key), mouse clicks, or scripting methods.
Default value
falseExamples
Markup and runtime examples for unfocusable:
Template + ref for imperative access:
<template> <smart-list-menu ref="listmenu" unfocusable /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.unfocusable = false;
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const unfocusable = w.unfocusable;
}
unlockKeyDefines or retrieves the unlockKey property, a unique identifier or code required to unlock and grant access to the product’s features or content.string
Defines or retrieves the unlockKey property, a unique identifier or code required to unlock and grant access to the product’s features or content.
Default value
""Examples
Markup and runtime examples for unlockKey:
Template:
<template> <smart-list-menu ref="listmenu" unlock-key="" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.unlockKey = "1111-2222-3333-4444-5555";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const unlockKey = w.unlockKey;
}
valueMemberSpecifies the name of the field in the data source whose value will be assigned as the item's value property. This field is used to uniquely identify each item within the data collection.string
Specifies the name of the field in the data source whose value will be assigned as the item's value property. This field is used to uniquely identify each item within the data collection.
Default value
"value"Examples
Markup and runtime examples for valueMember:
Template:
<template> <smart-list-menu ref="listmenu" value-member="info" /> </template>
Options API — after mount:
mounted() {
const w = this.$refs.listmenu;
w.valueMember = "details";
}Read the current value:
mounted() {
const w = this.$refs.listmenu;
const valueMember = w.valueMember;
}
Events
expandThis event is triggered whenever a smart-menu-items-group component is expanded by the user, indicating that the associated menu group has been opened to reveal its child menu items. Developers can use this event to perform actions such as loading dynamic content, updating UI states, or triggering additional functionality when a menu group becomes visible.CustomEvent
This event is triggered whenever a smart-menu-items-group component is expanded by the user, indicating that the associated menu group has been opened to reveal its child menu items. Developers can use this event to perform actions such as loading dynamic content, updating UI states, or triggering additional functionality when a menu group becomes visible.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onExpand
Arguments
evCustomEvent
ev.detailObject
ev.detail.item - The menu item that was expanded.
ev.detail.label - The label of the item that was expanded.
ev.detail.value - The value of the item that was expanded.
ev.detail.path - The path of the item that was expanded, e.g. '0.1', '1.1.2'.
ev.detail.children - The children of the item that was expanded.
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for expand using the pattern that matches your stack.
Template
<template><smart-list-menu @expand="onExpand"></smart-list-menu></template>
Script
export default {
name: "app",
methods: {
onExpand(event) {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value,
path = detail.path,
children = detail.children;
// event handling code goes here.
}
}
}
Imperative addEventListener on the same element as your template ref:
const w = this.$refs.listmenu;
w?.addEventListener('expand', (event) => {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value,
path = detail.path,
children = detail.children;
// event handling code goes here.
})
itemCheckChangeThis event is triggered whenever the checked or unchecked state of a menu item is modified—such as when a user selects or deselects a checkbox or toggle option within a menu. It allows you to respond to changes in the check state of menu items, enabling dynamic UI updates or additional actions based on the user's selection.CustomEvent
This event is triggered whenever the checked or unchecked state of a menu item is modified—such as when a user selects or deselects a checkbox or toggle option within a menu. It allows you to respond to changes in the check state of menu items, enabling dynamic UI updates or additional actions based on the user's selection.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onItemCheckChange
Arguments
evCustomEvent
ev.detailObject
ev.detail.item - The menu item which state was changed.
ev.detail.label - The label of the item which state was changed.
ev.detail.value - The value of the item which state was changed.
ev.detail.checked - The checked state of the toggled item. If false the item is not toggled.
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for itemCheckChange using the pattern that matches your stack.
Template
<template><smart-list-menu @itemCheckChange="onItemCheckChange"></smart-list-menu></template>
Script
export default {
name: "app",
methods: {
onItemCheckChange(event) {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value,
checked = detail.checked;
// event handling code goes here.
}
}
}
Imperative addEventListener on the same element as your template ref:
const w = this.$refs.listmenu;
w?.addEventListener('itemCheckChange', (event) => {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value,
checked = detail.checked;
// event handling code goes here.
})
itemClickThis event is triggered whenever a user interacts with the menu by clicking on one of its list items. The event provides details about the specific item selected, allowing you to execute custom logic in response to the user's selection.CustomEvent
This event is triggered whenever a user interacts with the menu by clicking on one of its list items. The event provides details about the specific item selected, allowing you to execute custom logic in response to the user's selection.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onItemClick
Arguments
evCustomEvent
ev.detailObject
ev.detail.item - The menu item that was clicked.
ev.detail.label - The label of the clicked item.
ev.detail.value - The value of the clicked item.
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for itemClick using the pattern that matches your stack.
Template
<template><smart-list-menu @itemClick="onItemClick"></smart-list-menu></template>
Script
export default {
name: "app",
methods: {
onItemClick(event) {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value;
// event handling code goes here.
}
}
}
Imperative addEventListener on the same element as your template ref:
const w = this.$refs.listmenu;
w?.addEventListener('itemClick', (event) => {
const detail = event.detail,
item = detail.item,
label = detail.label,
value = detail.value;
// event handling code goes here.
})
scrollBottomReachedThis event is triggered when the user reaches the bottom of the ListMenu by scrolling. It can be used to detect when additional actions are needed, such as loading more items or displaying a message, once the user has viewed all currently visible content in the ListMenu.CustomEvent
This event is triggered when the user reaches the bottom of the ListMenu by scrolling. It can be used to detect when additional actions are needed, such as loading more items or displaying a message, once the user has viewed all currently visible content in the ListMenu.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onScrollBottomReached
Arguments
evCustomEvent
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for scrollBottomReached using the pattern that matches your stack.
Template
<template><smart-list-menu @scrollBottomReached="onScrollBottomReached"></smart-list-menu></template>
Script
export default {
name: "app",
methods: {
onScrollBottomReached(event) {
// event handling code goes here.
}
}
}
Imperative addEventListener on the same element as your template ref:
const w = this.$refs.listmenu;
w?.addEventListener('scrollBottomReached', (event) => {
// event handling code goes here.
})
swipeleftThis event is triggered when the user performs a leftward swipe gesture within the ListMenu component, typically indicating an intent to reveal additional options, delete an item, or navigate to a different view. It is designed to respond exclusively to horizontal swipes that start inside the ListMenu area.CustomEvent
This event is triggered when the user performs a leftward swipe gesture within the ListMenu component, typically indicating an intent to reveal additional options, delete an item, or navigate to a different view. It is designed to respond exclusively to horizontal swipes that start inside the ListMenu area.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onSwipeleft
Arguments
evCustomEvent
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for swipeleft using the pattern that matches your stack.
Template
<template><smart-list-menu @swipeleft="onSwipeleft"></smart-list-menu></template>
Script
export default {
name: "app",
methods: {
onSwipeleft(event) {
// event handling code goes here.
}
}
}
Imperative addEventListener on the same element as your template ref:
const w = this.$refs.listmenu;
w?.addEventListener('swipeleft', (event) => {
// event handling code goes here.
})
swiperightThis event is triggered when the user performs a rightward swipe gesture within the ListMenu component. It can be used to detect and handle user interactions such as revealing additional options, navigating to a new view, or initiating specific actions in response to the right swipe inside the ListMenu area.CustomEvent
This event is triggered when the user performs a rightward swipe gesture within the ListMenu component. It can be used to detect and handle user interactions such as revealing additional options, navigating to a new view, or initiating specific actions in response to the right swipe inside the ListMenu area.
- Bubbles Yes
- Cancelable No
- Interface CustomEvent
- Event handler property onSwiperight
Arguments
evCustomEvent
Methods
isDefaultPrevented
Returns true if the event was prevented by any of its subscribers.
Returns
boolean true if the default action was prevented. Otherwise, returns false.
preventDefault
The preventDefault() method prevents the default action for a specified event. In this way, the source component suppresses the built-in behavior that follows the event.
stopPropagation
The stopPropagation() method of the Event interface prevents further propagation of the current event in the capturing and bubbling phases.
Examples
Listen for swiperight using the pattern that matches your stack.
Template
<template><smart-list-menu @swiperight="onSwiperight"></smart-list-menu></template>
Script
export default {
name: "app",
methods: {
onSwiperight(event) {
// event handling code goes here.
}
}
}
Imperative addEventListener on the same element as your template ref:
const w = this.$refs.listmenu;
w?.addEventListener('swiperight', (event) => {
// event handling code goes here.
})
Methods
addItem( Item: HTMLElement, Parent?: HTMLElement | string): voidAppends a new item to the end of the existing list, expanding the list by one element.
Appends a new item to the end of the existing list, expanding the list by one element.
Arguments
ItemHTMLElement
A smart-menu-item to add to the List Menu.
Parent?HTMLElement | string
The smart-menu-items-group (or its id or numeric path) to add the item to.
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu;
w?.addItem("document.createElement('smart-menu-item')","0");
Try a demo showcasing the addItem method.
back( animation?: boolean): voidNavigates to the previous page within the group of menu items (`smart-menu-items-group`). This function moves the user’s focus or view to the preceding set of menu options, enabling seamless backward navigation in multi-page or scrollable menu interfaces.
Navigates to the previous page within the group of menu items (`smart-menu-items-group`). This function moves the user’s focus or view to the preceding set of menu options, enabling seamless backward navigation in multi-page or scrollable menu interfaces.
Arguments
animation?boolean
If set to false, disables collapse animation even if animation is enabled for the element
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu; w?.back();
Try a demo showcasing the back method.
changePage( id: string): voidNavigates the user to a specific page or section within the application identified as "smart-menu-items-group." This action typically triggers a transition or redirect, bringing the "smart-menu-items-group" content into view for the user. Suitable for menu navigation or directing users to targeted groups within a menu structure.
Navigates the user to a specific page or section within the application identified as "smart-menu-items-group." This action typically triggers a transition or redirect, bringing the "smart-menu-items-group" content into view for the user. Suitable for menu navigation or directing users to targeted groups within a menu structure.
Arguments
idstring
The id or numeric path of a page (smart-menu-items-group).
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu;
w?.changePage("0.0");
Try a demo showcasing the changePage method.
checkItem( item: HTMLElement | string): voidMarks an item as checked, indicating that it has been selected or completed. This action typically updates the item's status property (e.g., `checked: true`) within the JSON data.
Marks an item as checked, indicating that it has been selected or completed. This action typically updates the item's status property (e.g., `checked: true`) within the JSON data.
Arguments
itemHTMLElement | string
smart-menu-item/smart-menu-items-group (or its id or numeric path).
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu;
w?.checkItem("0.0");
getItem( id: string): HTMLElementRetrieves a specific item using either its unique identifier (ID) or a numeric path that locates the item within a hierarchical structure.
Retrieves a specific item using either its unique identifier (ID) or a numeric path that locates the item within a hierarchical structure.
Arguments
idstring
The id or numeric path of an item
ReturnsHTMLElement
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu;
const result = w?.getItem("0.0");
maximize(): voidExpands the List Menu to its maximum available size, displaying all menu items for full visibility and easier selection.
Expands the List Menu to its maximum available size, displaying all menu items for full visibility and easier selection.
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu; w?.maximize();
minimize(): voidCollapses the List Menu to save screen space. When minimized, the full menu is hidden and replaced with a single icon, allowing users to expand the menu again if needed. This improves the user interface by providing a cleaner, less cluttered appearance while maintaining quick access to menu options.
Collapses the List Menu to save screen space. When minimized, the full menu is hidden and replaced with a single icon, allowing users to expand the menu again if needed. This improves the user interface by providing a cleaner, less cluttered appearance while maintaining quick access to menu options.
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu; w?.minimize();
removeItem( item: HTMLElement | string): voidRemoves a specified item from the collection or list. If the item exists, it is deleted; otherwise, no changes are made. This operation typically identifies the item by its unique key, index, or value.
Removes a specified item from the collection or list. If the item exists, it is deleted; otherwise, no changes are made. This operation typically identifies the item by its unique key, index, or value.
Arguments
itemHTMLElement | string
The smart-menu-item/smart-menu-items-group (or its id or numeric path) to remove.
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu;
w?.removeItem("0.0");
uncheckItem( item: HTMLElement | string): voidRemoves the checkmark from a selected item, resetting its state to unchecked or unselected. This action is typically used to indicate that the item is not active, chosen, or included in a selection.
Removes the checkmark from a selected item, resetting its state to unchecked or unselected. This action is typically used to indicate that the item is not active, chosen, or included in a selection.
Arguments
itemHTMLElement | string
smart-menu-item/smart-menu-items-group (or its id or numeric path).
From a method or lifecycle hook, via the template ref:
const w = this.$refs.listmenu;
w?.uncheckItem("0.0");
CSS Variables
--smart-list-menu-default-widthvar()
Default value
"var(--smart-box-width)"smartListMenu default width
--smart-list-menu-default-heightvar()
Default value
"var(--smart-box-height)"smartListMenu default height
--smart-list-menu-filter-input-vertical-offsetvar()
Default value
"5px"Defines vertical offset of the ListMenu's filter input.
--smart-list-menu-filter-input-horizontal-offsetvar()
Default value
"5px"Defines horizontal offset of the ListMenu's filter input.